//=============================================================================
// DawnsBlockablePath.
//
// A blockable/unblockable NavigationPoint.
//
// Version: 1.0
// $DateTime: Sat, 07/16/2005 12:36:41 am$
// Author: Dawn Knight
//
// UT Version Coded/Tested: 4.36.
//=============================================================================
class DawnsBlockablePath extends NavigationPoint;

var() bool      bInitiallyBlocked;
var() name		  BlockedTag;			 // Actor's tag name while Blocked.
var() name		  UnblockedTag;			 // Actor's tag name while Unblocked.

var   int       TriggerCount;

function PostBeginPlay()
{
	if ( !bInitiallyBlocked )
	{
		Tag = UnblockedTag;
		ExtraCost = 0;
	}
	else
	{
		Tag = BlockedTag;
		ExtraCost = 100000000;
	}
}

function Trigger( actor Other, pawn EventInstigator )
{
	if ( TriggerCount >= 2 )
	{
		Disable('Trigger');
		return;
	}
	TriggerCount++;
	if ( Tag == UnblockedTag )
	{
		Tag = BlockedTag;
		ExtraCost = 100000000;
	}
	else
	{
		Tag = UnblockedTag;
		ExtraCost = 0;
	}
}

