//=============================================================================
// DawnsSpectatorCam.
//
// A SpectatorCam that can be viewed from only when bEnabled.
// Fix for codebug in CHSpectator that checks for SpectatorCam.bSkipView and
// causes Client program crash.
//
// Version: 1.0
// $DateTime: Sat, 06/25/2005 09:28:35 am$
// Author: Dawn Knight
//
// UT Version Coded/Tested: 4.36 and compatible with UTPureRC7G.
//=============================================================================
class DawnsSpectatorCam extends SpectatorCam;

var(SpectatorCam) bool        bEnabled;

function BecomeViewTarget()
{
	local Pawn P;
	local CHSpectator S;

	bSkipView = false;

	if ( bEnabled )
		return;

	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
	{
		if ( P.IsA('CHSpectator') )
		{
			S = CHSpectator(P);
			if ( S.ViewTarget != None && S.ViewTarget == self )
			{
				S.ViewClass(class'SpectatorCam', true);
			}
		}
	}
}

function Trigger(actor Other, pawn EventInstigator)
{
	bEnabled = True;
}

defaultproperties
{
     bEnabled=False
     DrawType=DT_Sprite
     DrawScale=3
}
